require "narray"
require "dcl"
require "parameter"

module AdvancedDCL
  def param_init
    @param = Parameter.new
    @temp_param = @param.dup
  end

  private :param_init

  def param
    @param
  end

  def devopen(device, rot=false)
    if(rot == true)
      if(device == 'X')
	DCL.gropn(-1)
      elsif(device == 'PS')
	DCL.gropn(-2)
      elsif(device == 'Tek')
	DCL.gropn(-3)
      else
	raise ArgumentError, "device "+device.to_s+" is not exist"
      end
    else
      if(device == 'X')
	DCL.gropn(1)
      elsif(device == 'PS')
	DCL.gropn(2)
      elsif(device == 'Tek')
	DCL.gropn(3)
      else
	raise ArgumentError, "device "+device.to_s+" is not exist"
      end
    end
  end

  def devclose
    DCL.grcls
  end

  module_function :param_init
  module_function :param
  module_function :devopen
  module_function :devclose

  param_init
end

require "frame"
require "fig"
require "contour"
require "plot"
require "text"
require "axis"

