require "num/numarray"
require "advancesd"

include AdvancedDCL
include Math

nd = 12
ddeg = 360.0/nd
dd = 0.25

rx = dd * n * ((NumArray.span(Float, nd)*PI*ddeg/180).cos)
ry = dd * n * ((NumArray.span(Float, nd)*PI*ddeg/180).sin)

devopen("X")
Frame.new

Fig.window(0.0, 10.0, 0.0, 10.0)
Fig.viewport(0.0, 1.0, 0.0, 1.0)
Fig.transnum(1)

x1 = 3.0
y1 = 7.0
0..(nd-1).each{|i|
  Arrow.udrawz(x1, y1, x1+rx[i], y1+ry[i], 1, 2)
}

Arrow.lprop(false)
Arrow.const(0.05)

x1 = 7.0
y1 = 7.0
0..(nd-1).each{|i|
  Arrow.udrawz(x1, y1, x1+rx[i], y1+ry[i], 1, 2)
}

m = NumArray.span(Float, 8)
0..7.each{|i|
  Arrow.angle(10*m[i])
  Arrow.udrawz(m[i], 2.0, m[i]+1, 3.0, 1, 2)
}

devclose
