require "advanced"

include AdvancedDCL
include Math


n = 200
m = 5
x = Array.new(n)
y = Array.new(n)
yc = Array.new(m)
yc.each_index{|i|
  yc[i] = Array.new(n)
}
a = Array.new(m)

#-----------------------------------------------------------------------
dt = 1.0/(n-1)
for j in 0..m-1
  jj = j*2+1
  a[j] = (-1)**(j+1) *2.0/(jj*PI)
end

for i in 0..n-1
  t = dt*i*2*PI
  x[i] = dt*i
  y[i] = 0.0
  for j in 0..m-1
    jj = j*2+1
    yc[j][i] = a[j]*cos(jj*t)
    y[i]  = y[i] + yc[j][i]
  end
end

#--------------------------- 1ST PAGE ----------------------------------
devopen("X")

Frame.new
Fig.viewport=[0.2, 0.8, 0.2, 0.6]
Fig.window=[0.0, 1.0, -0.7, 0.7]

Axis.title('X-AXIS', ' ', 'COMPONENTS', ' ')
Axis.daxs
Plot.udraw(x, yc[0])

for j in 1..m-1
  ip = j.divmod(4)[1] + 1
  Plot.udrawz(x, yc[j], 1, ip)
end

#     --- NEW FIG ---
Fig.new
Fig.viewport=[0.2, 0.8, 0.62, 0.82]
Fig.window=[0.0, 1.0, -0.6, 0.6]
Axis.labelxb=false

Axis.title(' ', ' ', 'TOTAL', ' ')
Axis::daxs
#Axis::Lin.xaxdv('B', 0.05, 0.2)
#Axis.xaxs('T')
#Axis.yaxs('L')
#Axis.yaxs('R')
Plot.udraw(x, y)

#--------------------------- 2ND PAGE ----------------------------------
#Frame.new
#Fig.viewport=[0.2, 0.8, 0.2, 0.6]
#Fig.window=[0.0, 1.0, -0.7, 0.7]
#Axis::Lin.labelxb=true

#Axis.title('X-AXIS', ' ', 'COMPONENTS', ' ')
#Axis.xaxs('B')
#Axis.yaxs('L')
#Plot.udraw(x, yc[0])

#for j in 1..m-1
#  ip = j.divmod(4)[1] + 1
#  Plot.udrawz(x, yc[j], 1, ip)
#end

#     --- NEW FIG ---
#Fig.new
#Fig.viewport=[0.2, 0.8, 0.62, 0.82]
#Fig.window=[0.0, 1.0, -0.6, 0.6]
#Axis::Lin.labelxb=false

#Axis.title(' ', ' ', 'TOTAL', ' ')
#Axis.xaxs('B')
#Axis.yaxs('L')
#Plot.udraw(x, y)

devclose
