require "num/numarray"
require "advanced"

include AdvancedDCL
include Math


nx = 19
ny = 19
xmin = 0
xmax = 360
ymin = -90
ymax = 90
drad = PI/180
dz = 0.05
p = NumArray.new(Float, nx, ny)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    alon = (xmin + (xmax-xmin)*i/(nx-1)) * drad
    alat = (ymin + (ymax-ymin)*j/(ny-1)) * drad
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + dz
  end
end

#-- graph ---
devopen("X")

Tone.lsoftf(true)
Frame.new

Fig.window(xmin, xmax, ymin, ymax)
Fig.window(0.2, 0.8, 0.2, 0.8)
Fig.transnum(1)

Axis.daxs

Contour.draw(p)
Tone.draw(p)

devclose
