require "num/numarray"
require "advanced"

include AdvnacedDCL
include Math


n = 400
x = NumArray.new(Float, n)
y = NumArray.new(Float, n)

#-----------------------------------------------------------------------
dt = 2*PI/(n-1)
x.span(0.0, dt)
y.span(0.0, 2*dt)
y = y.sin * 10.0

#---------------------------- 1ST PAGE ---------------------------------
devopen("X")

Frame.new
Fig.xrange(x)
Fig.yrange(y)
Axis.draw
Line.udraw(x, y)

#---------------------------- 2ND PAGE ---------------------------------
rundef = DCL.glrget('RUNDEF')

Frame.new
Fig.window(0.0, 2.0*PI, rundef, rundef)

Axis.dxl(1.25)
Axis.dxt(0.25)

Axis.xfac(0.1)
Axis.yfac(10.0)

Fig.xrange(x)
Fig.yrange(y)
Axis.draw
Line.udraw(x, y)

#-----------------------------------------------------------------------

devclose
