require "num/numarray"
require "advanced"

include AdvancedDCL


n = 181
n1 = 26
n2 = 7
nc = 4
t = NumArray.new(Float, n)
y = NumArray.new(Float, n)
ux1 = NumArray.new(Float, n1)

#-----------------------------------------------------------------------
ch = ['JAN', 'FEB', 'MAR', 'APL', 'JUN', 'JULY', '   ']
ux2 = NumArray[0.0, 31.0, 59.0, 90.0, 120.0, 151.0, 181.0]

r = 0.2
a = 4.0
y[0] = 120.0
t.span(0.5, 1.0)
for i in 1..n-1
  r = a*r*(1.0-r)
  y[i] = y[i-1] + (r-0.46)*2
end

ux1.span(1.0, 7.0)

#-----------------------------------------------------------------------
rundef = glrget('RUNDEF')
uslset('LYINV', true)

devopen("X")
Frame.new

Fig.window(0.0, 181.0, rundef, rundef)
Fig.viewport(0.2, 0.8, 0.2, 0.8)
Fig.transnum(1)

Fig.yrange(y)

#------------------------------- Y-AXIS --------------------------------
Axis.yaxs('L')
Axis.yaxs('R')
Axis::Lin.ytitle('L', 'YEN/DOLLAR', 0.0)

#------------------------------- X-AXIS --------------------------------
Axis::Lin.lbtwn(true)
Axis::Lin.axlb('B', ux1, ux2, ch)
Axis::Lin.axlb('T', ux1, ux2, ch)
Axis::Lin.xtitle('T', 'EXCHANGE RATE', 0.0)

#-------------------------------- LINE ---------------------------------
Line.udraw(t, y)

devclose

