require "num/numarray"
require "advanced"

include AdvancedDCL


nt = 51
nz = 21
zmin = 20.0
zmax = 50.0
tmax = 5.0
dz = (zmax-zmin)/(nz-1)
dt = tmax/(nt-1)
u = NumArray.new(Float, nt, nz)

#-----------------------------------------------------------------------
for j in 0..nz-1
  z  = dz*j
  uz = exp(-0.2*z)*(z**0.5)
  for i in 0..nt-1
    t  = dt*i - 2*exp(-0.1*z)
    u[i,j] = uz*sin(3.0*t)
  end
end

#-----------------------------------------------------------------------
devopen("X")

Frame.new

Fig.window(0.0, tmax, zmin, zmax)
Fig.viewport(0.2, 0.8, 0.2, 0.8)
Fig.transnum(1)

Axis.title('TIME', 'YEAR', 'HEIGHT', 'km')

Axis.daxs

Contour.draw(u, nt, nt, nz)

devclose
