module AdvancedDCL
  module Fig
    def param_init
      @param = Parameter.new(AdvancedDCL.param)
      @param.init("mapangle", [3, Float], "grsmpl", "sgqmpl", 2, 1)
      @param.init("simtrans", [3, Float], "grssim", "sgqsim", 2, 1)
      @param.init("transnum", Fixnum, "grstrn", "sgqtrn", 1, 1)
      @param.init("transnum3d", Fixnum, "scstrn", "scqtrn", 1, 1)
      @param.init("viewport", [4, Float], "grsvpt", "sgqvpt", 2, 1)
      @param.init("viewport3d", [4, Float], "scsvpt", "scqvpt", 2, 1)
      @param.init("window", [4, Float], "grswnd", "sgqwnd", 2, 1)
      @param.init("window3d", [4, Float], "scswnd", "scqwnd", 2, 1)
      
      @param.init("contactpoint", [3, Float], "umscnt", "umqcnt", 2, 1)
      @param.init("circlewindow", [3, Float], "umscwd", "umqcwd", 2, 1)
      @param.init("inclpoint", [2, [true, Float]], "inclpoint", "", 3, 3)
      
      @param.init("xrange", [true, Float], "xrange", "usqxex", 3, 1)
      @param.init("yrange", [true, Float], "yrange", "usqyex", 3, 1)

      @param.init("lclip", TrueClass, "sglset", "sglget", 0, 0)

      @temp_param = @param.dup

      @grstrf = false       # true:called, flase:not called  
      @scstrf = false       # true:called, flase:not called  
    end
    
    private :param_init	
    
    def new
      @grstrf = false
      @scstrf = false
      DCL.grfig
    end
    
#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
      trfnew
    end

    def settrf
      if(!@grstrf)
	@param.sync
	DCL.uspfit
	DCL.grstrf
	trfclear
      end
    end

    def set3dtrf
      if(!@grstrf)
	@param.sync
	DCL.uspfit
	DCL.scstrf
	trfclear
      end
    end

    def trfclear
      @grstrf = true
      @scstrf = true
    end

    def trfnew
      @grstrf = false
      @scstrf = false
    end

#----------- draw method -------------

    def pvpr(index)
      DCL.slpvpr(index)
    end

    def pwwr(index)
      DCL.slpwwr(index)
    end

    def pwvr(index)
      DCL.slpwvr(index)
    end

    def pvpc(index, rc)
      DCL.pvpc(index, rc)
    end

    def pwwc(index, rc)
      DCL.pwwc(index, rc)
    end

    def pwvc(index, rc)
      DCL.slpwvc(index, rc)
    end

    private :trfclear
    
    module_function :param_init
    module_function :new
    module_function :set
    module_function :settrf
    module_function :trfnew
    module_function :trfclear
    module_function :set3dtrf
    module_function :pvpr
    module_function :pwwr
    module_function :pwvr
    module_function :pvpc
    module_function :pwwc
    module_function :pwvc
    
    param_init

#------------------- singleton methods ----------------------

    def @param.inclpoint(point)
      DCL.usspnt(point[0].length, point[0], point[1])
    end

    def @param.xrange(x)
      DCL.ussxex(x.length, x)
    end

    def @param.yrange(y)
      DCL.ussyex(y.length, y)
    end
    
#----------------------------------------------------------

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
