module AdvancedDCL
  module Frame
    def param_init
      @param = Parameter.new(AdvancedDCL.param)
      @param.init("lfull", TrueClass, "sglset", "sglget", 0, 0)

      @temp_param = @param.dup
    end
    
    private :param_init

    def new
      @param.sync
#      DCL.sgfrm
      DCL.grfrm
      Fig.trfnew
    end

    def size(csize)
      DCL.slsize(csize)
    end
    
    def form(dxa, dya)
      DCL.slform(dxa, dya)
    end
    
    def div(cform, ix, iy)
      DCL.sldiv(cform, ix, iy)
    end
    
    def mgn(xl, xr, yb, yt)
      DCL.slmgn(xl, xr, yb, yt)
    end

    def rat(rx, ry)
      DCL.slrat(rx, ry)
    end

    def settitle(title, cside, px, py, ht, nt)
      DCL.slsttl(title, cside, px, py, ht, nt)
    end
  
    def set(key, val)
      @param[key] = val
    end

    module_function :param_init
    module_function :new
    module_function :size
    module_function :form
    module_function :div
    module_function :mgn
    module_function :rat
    module_function :settitle
    module_function :set

    param_init
  end
end
