require "fig"
#require "axis"

module AdvancedDCL
  module Axis
    module Log
      def param_init
	@param = Parameter.new(Axis.param)
	
	@param.init("ixchr", Fixnum, "uliset", "uliget", 0, 0)
	@param.init("iychr", Fixnum, "uliset", "uliget", 0, 0)
	@param.init("ixtype", Fixnum, "uliset", "uliget", 0, 0)
	@param.init("iytype", Fixnum, "uliset", "uliget", 0, 0)
	@param.init("xlabelfmt", String, "ulxsfm", "ulxqfm", 1, 1)
	@param.init("ylabelfmt", String, "ulysfm", "ulyqfm", 1, 1)

	@temp_param = @param.dup
      end

      private :param_init

 #------------------- method for parameters----------------------

      def set(key, val)
	@param[key]=val
      end
 
      def xlabelset(value)
	DCL.ulsxbl(value, value.length)
      end

      def ylabelset(value)
	DCL.ulsybl(value, value.length)
      end
      
#----------------------------------------------------------
#------------ draw method ----------------------

      def xdraw(cside, nlabel, nticks, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf

	DCL.ulxlog(cside, nlabel, nticks)
	@backup.sync
	@temp_param.clear
      end

      def ydraw(cside, nlabel, nticks, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.ulylog(cside, nlabel, nticks)
	@backup.sync
	@temp_param.clear
      end

      module_function :param_init
      module_function :set
      module_function :xlabelset
      module_function :ylabelset
      module_function :xdraw
      module_function :ydraw

      param_init

      @param.keys.each{|i|
	eval "def #{i}; @param['#{i}']; end"
	eval "def #{i}=(val); set('#{i}', val); end"
      }
      
      @param.keys.each{|i|
	eval "module_function :#{i}"
	eval "module_function :#{i}="
      }
    end
  end
end
