module AdvancedDCL
  module Plot
    def param_init
      @param = Parameter.new(AdvancedDCL.param)
      @param.init("nbits", Float, "sgrset", "sgrget", 0, 0)
      @param.init("bitlen", Float, "sgrset", "sgrget", 0, 0)
      @param.init("move", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("lchar", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("lrot", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("irot", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("fwc", Float, "sgrset", "sgrget", 0, 0)
      @param.init("cwl", Float, "sgrset", "sgrget", 0, 0)
      @param.init("ffct", Float, "sgrset", "sgrget", 0, 0)
      @param.init("indexc", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("lbuff", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("nbuff", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("rbuff", Float, "sgrset", "sgrget", 0, 0)
      @param.init("lcury", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("rcury", Float, "sgrset", "sgrget", 0, 0)
      @param.init("lineindex", Fixnum, "lineindex", "lineindexget", 3, 3)
      @param.init("linetype", Fixnum, "uuslnt", "uuqlnt", 1, 1)
      
      @temp_param = @param.dup
      
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def udraw(x, y, temp=false)
      @param.sync
      @backup = @temp_param.set(temp, @param)
      @temp_param.sync

      Fig.settrf

      DCL.uulin(x.length, x, y)
      @backup.sync
      @temp_param.clear
    end

    def udrawz(x, y, type, index, temp=false)
      @param.sync
      @backup = @temp_param.set(temp, @param)
      @temp_param.sync

      Fig.settrf

      DCL.uulinz(x.length, x, y, type, index)
      @backup.sync
      @temp_param.clear
    end

    def vdraw(x, y, temp=false)
      @param.sync
      @backup = @temp_param.set(temp, @param)
      @temp_param.sync

      Fig.settrf

      DCL.sgplv(x.length, x, y)
      @backup.sync
      @temp_param.clear
    end

    def vdrawz(x, y, type, index, temp=false)
      @param.sync
      @backup = @temp_param.set(temp, @param)
      @temp_param.sync

      Fig.settrf

      DCL.sgplzv(x.length, x, y, type, index)
      @backup.sync
      @temp_param.clear
    end

    def setlabel(label)
      DCL.sgsplc(label)
    end

    def nplc
      DCL.sgnplc
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :udraw
    module_function :udrawz
    module_function :vdraw
    module_function :vdrawz
    module_function :setlabel
    module_function :nplc

    param_init
    
#----------------------------------------------------------
    def @param.lineindex(index)
      DCL.uuslni(index)
      DCL.sgspli(index)
    end

    def @param.lineindexget
      DCL.uuqlni
    end

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
